<?php

function CreateDataPlace()
{

	global	$modDataDir
	,		$modsDataDir;

	if(!file_exists($modDataDir))
	{
		
		if(!file_exists($modsDataDir))
		{
			mkdir($modsDataDir);
			chmod($modsDataDir,0777);
		}
		
		mkdir($modDataDir);
		chmod($modDataDir,0777);
	
	}

}

function SetAnswers(&$data)
{
	$f=fopen($GLOBALS['voteFile'],'w');
	if($f)
	{
		$count=sizeof($data);
		$i=0;
		foreach($data as $key=>$val)
		{
			fwrite($f,$key.':'.$val);
			if(++$i<$count)
				fwrite($f,"\n");
		}
		fclose($f);
	}
}

function MergeAnswers(&$new,&$old)
{

	$result=false;

	if($new!=$old){
		foreach($new as $key=>$val){
			if(isset($old[$key])){
				$new[$key]=$old[$key];
			}
		}
		$result=true;
	}

	return $result;

}

function UpdateAnswersReal()
{
	
	global $modDataDir;

	$new=false;
	$old=false;
	
	if(file_exists($GLOBALS['voteFileName'])){
		ReadAnswersToArray($GLOBALS['voteFileName'],$new);
	}
		
	if($new!==false&&file_exists($GLOBALS['voteFile'])){
		ReadAnswersToArray($GLOBALS['voteFile'],$old);
	}

	if($new!==false){
		if($old!==false&&!MergeAnswers($new,$old)){
			return;
		}
		SetAnswers($new);
	}
	
}

function UpdateAnswers()
{
	
	global	$modDataDir;

	$time=$timeNew=0;

	if(file_exists('data_time_new'))
	{
		$timeFileNew=fopen('data_time_new','r');
		if($timeFileNew)
			$timeNew=trim(fread($timeFileNew,1024));
		if(file_exists($modDataDir.'data_time')&&$timeFileNew)
		{
			$timeFile=fopen($modDataDir.'data_time','r+');
			if($timeFile)
				$time=trim(fread($timeFile,1024));
			if($timeFile&&$time==$timeNew)
				fclose($timeFile);
		}
		if($timeFileNew)
			fclose($timeFileNew);
	}

	if($time!=$timeNew)
	{
		if(!isset($timeFile))
			$timeFile=fopen($modDataDir.'data_time','w');
		if($timeFile)
		{
			UpdateAnswersReal();
			ftruncate($timeFile,0);
			fseek($timeFile,0,SEEK_SET);
			fwrite($timeFile,$timeNew);
			fclose($timeFile);
		}
	}
	
}


function ReadAnswersToArray($voteFile,&$votes) {
	
	$votes=array();
	$file=file_exists($voteFile) ? file($voteFile) : false;
		
	if ($file) {
		foreach ($file as $line) {
			$line=trim($line);
			$parsed=explode(':',$line);
        	if (sizeof($parsed)!=2) {
        		continue;
        	}
        	$votes[$parsed[0]]=$parsed[1];
		}
	}

}


?>